﻿Imports System.Security.Principal
Imports System.Threading

Module Module1

  Sub Main()
    Dim principal As New System.Security.Principal.WindowsPrincipal(System.Security.Principal.WindowsIdentity.GetCurrent())
    Dim isAdmin As Boolean = principal.IsInRole(System.Security.Principal.WindowsBuiltInRole.Administrator)

    Console.WriteLine(New IO.FileInfo(Reflection.Assembly.GetEntryAssembly().Location).Name)
    If isAdmin = True Then
      Console.WriteLine("Als Admin angemeldet")
    Else
      Console.WriteLine("Nicht als Admin angemeldet")
    End If

    'DemonstrateWindowsBuiltInRoleEnum()

    'Console.Read()

  End Sub

  Public Sub DemonstrateWindowsBuiltInRoleEnum()
    Dim myDomain As AppDomain = Thread.GetDomain()

    myDomain.SetPrincipalPolicy(PrincipalPolicy.WindowsPrincipal)
    Dim myPrincipal As WindowsPrincipal = CType(Thread.CurrentPrincipal, WindowsPrincipal)
    Console.WriteLine("{0} belongs to: ", myPrincipal.Identity.Name.ToString())
    Dim wbirFields As Array = [Enum].GetValues(GetType(WindowsBuiltInRole))
    Dim roleName As Object
    For Each roleName In wbirFields
      Try
        ' Cast the role name to a RID represented by the WindowsBuildInRole value.
        Console.WriteLine("{0}? {1}.", roleName, myPrincipal.IsInRole(CType(roleName, WindowsBuiltInRole)))
        Console.WriteLine("The RID for this role is: " + Fix(roleName).ToString())

      Catch
        Console.WriteLine("{0}: Could not obtain role for this RID.", roleName)
      End Try
    Next roleName
    ' Get the role using the string value of the role.
    Console.WriteLine("{0}? {1}.", "Administrators", myPrincipal.IsInRole("BUILTIN\" + "Administrators"))
    Console.WriteLine("{0}? {1}.", "Users", myPrincipal.IsInRole("BUILTIN\" + "Users"))
    ' Get the role using the WindowsBuiltInRole enumeration value.
    Console.WriteLine("{0}? {1}.", WindowsBuiltInRole.Administrator, myPrincipal.IsInRole(WindowsBuiltInRole.Administrator))
    ' Get the role using the WellKnownSidType.
    Dim sid As New SecurityIdentifier(WellKnownSidType.BuiltinAdministratorsSid, Nothing)
    Console.WriteLine("WellKnownSidType BuiltinAdministratorsSid  {0}? {1}.", sid.Value, myPrincipal.IsInRole(sid))

  End Sub 'DemonstrateWindowsBuiltInRoleEnum

End Module
